//based on a sketch and patch by colorsound

#include <FastLED.h> //implement FastLED lib
#define NUM_STRIPS 9
#define NUM_LEDS_PER_STRIP 8
#define NUM_LEDS NUM_LEDS_PER_STRIP * NUM_STRIPS

CRGB leds[NUM_STRIPS * NUM_LEDS_PER_STRIP]; //Array for RGB LEDs
int LEDValues[NUM_STRIPS * NUM_LEDS_PER_STRIP][3]; //Two dimensional array (60,3) to store RGB values for every LED
//char packetBuffer[26]; //Buffer to store incoming string from vvvv  BUFFER (buffer  nombre de led x3 +2 ) 150*3+2=452
char packetBuffer[452];
//CRGB leds2[NUM_LEDS]; //Array for RGB LEDs
//int LEDValues2[NUM_LEDS][3]; //Two dimensional array (60,3) to store RGB values for every LED
//char packetBuffer2[452]; 


void setup()   
{
 
  FastLED.addLeds<NEOPIXEL, 1>(leds, 0, 8); //initiate RGB LED strip
  FastLED.addLeds<NEOPIXEL, 2>(leds, 9,16); //initiate RGB LED strip//initiate RGB LED strip
  FastLED.addLeds<NEOPIXEL, 0>(leds, 17, 24);
  FastLED.addLeds<NEOPIXEL, 4>(leds, 25, 32);
   FastLED.addLeds<NEOPIXEL, 5>(leds, 33, 40);
    FastLED.addLeds<NEOPIXEL, 6>(leds, 41, 48);
  FastLED.addLeds<NEOPIXEL, 7>(leds, 49, 56);
  FastLED.addLeds<NEOPIXEL, 8>(leds, 57, 64);
   FastLED.addLeds<NEOPIXEL, 9>(leds, 65, 72);
//  Serial.begin(9600); //start Serial Communication
 //   FastLED.addLeds<NEOPIXEL, DATA_PIN2>(leds2, NUM_LEDS); //initiate RGB LED strip
//  Serial2.begin(9600); //start Serial Communication
}
void loop() {
  if (Serial.available() > 0) //Check if data is coming in through serial
  {
    Serial.readBytes(packetBuffer,452);// 182 is the packetsize = 180 values + '<' and '>'
    if( packetBuffer[0]=='<' && packetBuffer[452-1]=='>') //if first and last chars of string are '<' and '>' we know the whole package has arrived
    {
    unsigned char CleanBuffer [452]; //new Array to store string without starting and closing tag
      memcpy(CleanBuffer,packetBuffer+1,452-2); //copies the content from packetBuffer to CleanBuffer excluding the first and last element
      
      int index=0; //helper to point to a specific data point
      
      for(int i=0; i<NUM_LEDS; i++) //nested for loop to run through two dimensional array
      {
        for(int j=0; j<3; j++)
        {
          LEDValues[i][j] = CleanBuffer[index]; //store values of CleanBuffer in 2D Array
          index++; //increase index to get next data point in next run through the loop
        }
      }
    }
  }
  
  for(int i=0; i<NUM_LEDS; i++) //for loop to push values to LEDs
  {
  // leds[i] = CRGB::Red;
  //  FastLED.show();
  //  leds[i] = CRGB::Black;
 //   delay(100);
    leds[i] = CRGB(LEDValues[i][0],LEDValues[i][1],LEDValues[i][2]);
  }
  
  FastLED.show(); //updated RGB LED strip
  delay(5);

 } 
